(function() {
	/*
	 * ファイルアップロード
	 */
	upload = function() {
		//	LocalFileSystem : Number	ファイルシステムの種別を指定します。
		//								TEMPORARY：テンポラリーのファイルシステム
		//								PERSISTENT：永続的なファイルシステム
		//	size            : Number	アプリケーションがストレージとして必要とするサイズを指定します。（バイト単位）
		//	successCallback : Function<FileSystem>	ファイルシステムを取得出来た場合にCallbackされます。
		//	errorCallback   : Function<Error>	ファイルシステムを取得出来なかった場合にCallbackされます。
		applican.requestFileSystem(LocalFileSystem.PERSISTENT, 0, uploadGotFS, uploadError);
	}

	/*
	 * FileEntry取得
	 */
	function uploadGotFS(fileSystem) {
		// fileSystem.root.getFile("readme.txt", null, uploadGotFileEntry, uploadError);
		fileSystem.root.getFile("sample.zip", null, uploadGotFileEntry, uploadError);
	}

	/*
	 * ファイルアップロード
	 */
	function uploadGotFileEntry(fileEntry) {
		var options = new FileUploadOptions();
		//キー
		options.fileKey = "file";
		//ファイル名
		// options.fileName = "readme.txt";
		options.fileName = "sample.zip";
		//ファイルタイプ
		// options.mimeType = "text/plain";

		//パラメータ
		var params = {};
		params.value1 = "test";
		params.value2 = "param";
		options.params = params;

		// var ft = new FileTransfer();
		var ft = applican.filesystem.createFileTransfer();
		//アップロード進捗を表示
		ft.onprogress = function(evt) {
			document.getElementById("dumpAreaFile").value = evt.loaded + "/" + evt.total;
		};

		//アップロード
		var uploadURL = document.getElementById("uploadPath").value;
		ft.upload(fileEntry.fullPath, encodeURI(uploadURL), uploadSuccess, uploadError, options);
	}

	/*
	 * ファイルアップロード成功時のcallback処理
	 */
	function uploadSuccess(result) {
		var dump = "ファイルアップロードしました。\n";
		dump    += "responseCode : " + result.responseCode + "\n";
		dump    += "response : "     + result.response     + "\n";
		dump    += "bytesSent : "    + result.bytesSent    + "\n";
		document.getElementById("dumpAreaFile").value = dump;
	}

	/*
	 * ファイルアップロード失敗時のcallback処理
	 */
	function uploadError(error) {
		var dump = "ファイルアップロードに失敗しました。\n";
		dump    += "code : "        + error.code        + "\n";
		dump    += "source : "      + error.source      + "\n";
		dump    += "target : "      + error.target      + "\n";
		dump    += "http_status : " + error.http_status + "\n";
		document.getElementById("dumpAreaFile").value = dump;
		alert(dump);
	}

	/*
	 * ファイルアップロードを中断
	 */
	abortUpload = function(){
		//パラメータ：
		//	LocalFileSystem : Number	ファイルシステムの種別を指定します。
		//								TEMPORARY：テンポラリーのファイルシステム
		//								PERSISTENT：永続的なファイルシステム
		//	size : Number	アプリケーションがストレージとして必要とするサイズを指定します。（バイト単位）
		//	successCallback : Function<FileSystem>	ファイルシステムを取得出来た場合にCallbackされます。
		//	errorCallback : Function<Error>	ファイルシステムを取得出来なかった場合にCallbackされます。
		applican.requestFileSystem(LocalFileSystem.PERSISTENT, 0, abortuploadGotFS, abortUploadAbortError);
	}

	/*
	 * FileEntry取得
	 */
	function abortuploadGotFS(fileSystem) {
		fileSystem.root.getFile("sample.zip", null, abortuploadGotFileEntry, abortUploadAbortError);
	}

	/*
	 * ファイルアップロードを中断
	 */
	function abortuploadGotFileEntry(fileEntry) {
		var options = new FileUploadOptions();
		//キー
		options.fileKey = "file";
		//ファイル名
		options.fileName = "sample.zip";
		//ファイルタイプ
		// options.mimeType = "text/plain";

		//パラメータ
		var params = {};
		params.value1 = "test";
		params.value2 = "param";
		options.params = params;

		// var ft = new FileTransfer();
		var ft = applican.filesystem.createFileTransfer();
		var uploadURL = document.getElementById("uploadPath").value;

		//アップロード進捗を表示
		ft.onprogress = function(evt) {
			document.getElementById("dumpAreaFile").value = evt.loaded + "/" + evt.total;
		};
		//アップロード
		ft.upload(fileEntry.fullPath, encodeURI(uploadURL), uploadSuccess, uploadError, options);
		//ファイルアップロードを中断
		ft.abort(abortUploadAbortSuccess, abortUploadAbortError);
	}

	/*
	 * アップロードを中断成功時のcallback処理
	 */
	function abortUploadAbortSuccess() {
		var dump = "アップロードを中断しました。\n";
		document.getElementById("dumpAreaFile").value = dump;
	}

	/*
	 * アップロードを中断失敗時のcallback処理
	 */
	function abortUploadAbortError() {
		var dump = "アップロードの中断に失敗しました。\n";
		document.getElementById("dumpAreaFile").value = dump;
		alert(dump);
	}

	/*
	 * 撮影してアップロード
	 * 		撮影の詳細は「Camera」APIを参照してください。
	 * 		http://doc.applican.com/Camera/index.html
	 */
	getPictureAndUpload = function() {
		var options = {
			quality: 50,
			destinationType: applican.camera.DestinationType.FILE_URI,
			sourceType: applican.camera.PictureSourceType.CAMERA,
			targetWidth: 400,
			targetHeight: 400,
			saveToPhotoAlbum: true
		};
		applican.camera.getPicture(
			uploadPhoto,
			function(message) { alert("写真の取得に失敗しました。"); },
			options
		);
	}

	/*
	 * 画像をアップロード
	 */
	function uploadPhoto(imageURI) {
		var options = new FileUploadOptions();
		//キー
		options.fileKey = "file";
		//ファイル名
		options.fileName = imageURI.substr(imageURI.lastIndexOf("/") + 1);
		//ファイルタイプ
		options.mimeType = "image/jpeg";
		//パラメーター
		var params = {};
		params.value1 = "test";
		params.value2 = "param";
		options.params = params;

		// var ft = new FileTransfer();
		var ft = applican.filesystem.createFileTransfer();
		var uploadURL = document.getElementById("uploadPath").value;
		//アップロード
		ft.upload(imageURI, encodeURI(uploadURL), uploadPhotoSuccess, uploadPhotoFail, options);
	}

	/*
	 * アップロード成功時のcallback処理
	 */
	function uploadPhotoSuccess(r) {
		var dump = "画像をアップロードしました。\n";
		dump += "コード = " + r.responseCode + "\n";
		dump += "結果 = " + r.response + "\n";
		dump += "送信バイト数 = " + r.bytesSent + "\n";
		document.getElementById("dumpAreaFile").value = dump;
	}

	/*
	 * アップロード失敗時のcallback処理
	 */
	function uploadPhotoFail(error) {
		var dump = "画像のアップロードに失敗しました。\n";
		dump += "code : " + error.code + "\n";
		document.getElementById("dumpAreaFile").value = dump;
		alert(dump);
	}

	//ファイル転送用オブジェクト
	var ftDownload;
	/*
	 * ファイルダウンロード
	 */
	download = function() {
		//パラメータ：
		//	LocalFileSystem : Number	ファイルシステムの種別を指定します。
		//								TEMPORARY：テンポラリーのファイルシステム
		//								PERSISTENT：永続的なファイルシステム
		//	size            : Number	アプリケーションがストレージとして必要とするサイズを指定します。（バイト単位）
		//	successCallback : Function<FileSystem>	ファイルシステムを取得出来た場合にCallbackされます。
		//	errorCallback   : Function<Error>	ファイルシステムを取得出来なかった場合にCallbackされます。
		applican.requestFileSystem(LocalFileSystem.PERSISTENT, 0, downloadGotFS, downloadError);
	}

	/*
	 * FileEntry取得
	 */
	function downloadGotFS(fileSystem) {
		var filePath = fileSystem.root.fullPath + "/sample.zip";
		// ftDownload = new FileTransfer();
		ftDownload = applican.filesystem.createFileTransfer();
		var downloadURL = document.getElementById("downloadPath").value;

		//ダウンロード進捗を表示
		ftDownload.onprogress = function(evt) {
			document.getElementById("dumpAreaFile").value = evt.loaded + "/" + evt.total;
		};
		//ダウンロード
		ftDownload.download(encodeURI(downloadURL), filePath, downloadSuccess, downloadError);
	}

	/*
	 * ファイルダウンロード成功時のcallback処理
	 */
	function downloadSuccess(entry) {
		var dump = "ファイルをダウンロードしました。\n";
		dump    += "name : "     + entry.name     + "\n";
		dump    += "fullPath : " + entry.fullPath + "\n";
		document.getElementById("dumpAreaFile").value = dump;
		ftDownload = null;
	}

	/*
	 * ファイルダウンロード失敗時のcallback処理
	 */
	function downloadError(error) {
		var dump = "downloadError\n";
		dump    += "code : "        + error.code        + "\n";
		dump    += "source : "      + error.source      + "\n";
		dump    += "target : "      + error.target      + "\n";
		dump    += "http_status : " + error.http_status + "\n";
		document.getElementById("dumpAreaFile").value = dump;
		ftDownload = null;
		alert(dump);
	}

	/*
	 * ファイルダウンロードを中断
	 */
	abortDownload = function(){
		if(ftDownload) {
			// ファイルダウンロードを中断
			ftDownload.abort(abortDownloadSuccess, abortDownloadError);
		} else {
			alert("ダウンロードを開始してください。");
		}
	}

	/*
	 * ファイルダウンロード中断成功時のcallback処理
	 */
	function abortDownloadSuccess() {
		alert("ダウンロードを中断しました。");
	}

	/*
	 * ファイルダウンロード中断失敗時のcallback処理
	 */
	function abortDownloadError() {
		var dump = "ファイルダウンロードの中断に失敗しました。\n";
		document.getElementById("dumpAreaFile").value = dump;
		alert(dump);
	}

	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「ファイルアップロード」ボタン押下処理
		document.getElementById("uploadBtn").addEventListener("touchend", upload, false);
		// 「ファイルアップロードを中断」ボタン押下処理
		document.getElementById("abortUploadBtn").addEventListener("touchend", abortUpload, false);
		// 「撮影してアップロード」ボタン押下処理
		document.getElementById("getPictureAndUploadBtn").addEventListener("touchend", getPictureAndUpload, false);
		// 「ファイルダウンロード」ボタン押下処理
		document.getElementById("downloadBtn").addEventListener("touchend", download, false);
		// 「ファイルダウンロードを中断」ボタン押下処理
		document.getElementById("abortDownloadBtn").addEventListener("touchend", abortDownload, false);
	}, false);
})();
